<script setup lang="ts">
import { defineProps, ref, watch, computed } from "vue";
import { useRoute, useRouter } from "vue-router";

const { totalItems, itemsPerPage } = defineProps({
  totalItems: {
    type: Number,
    required: true,
  },
  itemsPerPage: {
    type: Number,
    required: true,
  },
});

const router = useRouter();
const route = useRoute();

const currentPage = ref<number>(1);

watch(() => route.query.page, (newPage) => {
  currentPage.value = Number(newPage) || 1;
});

const onClickHandler = (page: number) => {
  router.push({ path: route.path, query: { page: page.toString() } });
};
</script>

<template>
  <vue-awesome-paginate
      :total-items="totalItems"
      :items-per-page="itemsPerPage"
      :max-pages-shown="3"
      v-model="currentPage"
      :on-click="onClickHandler"
  />
</template>

<style>
.pagination-container {
  display: flex;
  column-gap: 10px;
}
.paginate-buttons {
  height: 36px;
  width: 37px;
  border-radius: 6px;
  cursor: pointer;
  color: white;
  opacity: 40%;
}
.paginate-buttons:hover {
  background-color: #d8d8d8;
}
.active-page {
  background-color: #5051F9;
  color: white;
  opacity: 100%;
}
.active-page:hover {
  background-color: #2988c8;
}
.back-button {
  color: #5051F9;
  opacity: 100%;
}
.next-button {
  color: #5051F9;
  opacity: 100%;
}
.back-button:hover {
  color: #5051F9;
  opacity: 100%;
  background-color: transparent;
}
.next-button:hover {
  color: #5051F9;
  opacity: 100%;
  background-color: transparent;
}
</style>